/*
===============================================================================
 Name        : main.c
 Author      : 
 Version     :
 Copyright   : Copyright (C) 
 Description : main definition
===============================================================================
*/

#include "LPC177x_8x.h"

#include <cr_section_macros.h>
#include <NXP/crp.h>

#include "lpc177x_8x_clkpwr.h"
#include "lpc177x_8x_pinsel.h"
#include "lpc177x_8x_uart.h"
//#include "uart.h"
#include <string.h>
#include <stdio.h>

// Variable to store CRP value in. Will be placed automatically
// by the linker when "Enable Code Read Protect" selected.
// See crp.h header for more information
__CRP const unsigned int CRP_WORD = CRP_NO_CRP ;

// TODO: insert other include files here

// TODO: insert other definitions and declarations here

#define LED_PORT LPC_GPIO4
#define LED_PIN  0

UART_FIFO_CFG_Type UARTFIFOConfigStruct;


UART_CFG_Type UART_InitStruct; /*= {
    57600,
    UART_PARITY_NONE,
    UART_DATABIT_8,
    UART_STOPBIT_1
};
			       */

// IRQ
volatile unsigned long SysTickCnt;

void SysTick_Handler (void)
{
    SysTickCnt++;
}

// IRQ END
void Delay (unsigned long tick)
{
    unsigned long systickcnt;
    
    systickcnt = SysTickCnt;
    while ((SysTickCnt - systickcnt) < tick);
}

void init_timer (void) {
    uint32_t cclk = CLKPWR_GetCLK(CLKPWR_CLKTYPE_CPU);
    SysTick_Config(cclk/1000 - 1);
}

void myinit_uart (void) {
    PINSEL_ConfigPin(0,2,1);

    UART_ConfigStructInit(&UART_InitStruct);

    UART_Init(LPC_UART0, &UART_InitStruct);	// baud rate setting
    LPC_GPIO4->SET |= (1<<0);
    UART_FIFOConfigStructInit(&UARTFIFOConfigStruct);
    UART_FIFOConfig(LPC_UART0, &UARTFIFOConfigStruct);
    // Enable UART Transmit
    UART_TxCmd(LPC_UART0, ENABLE);
}

unsigned char string[80] = "My Test!!!";

int main(void) {
    // TODO: insert code here

//    uint8_t menu2[] = "\n\rUART Polling demo terminated!";
    
//    LPC_GPIO_TypeDef *a;

    SystemInit();
    init_timer();
/*
    uint64_t best_divisor, divisor, tmp64;

    best_divisor = CLKPWR_GetCLK(CLKPWR_CLKTYPE_PER);
    best_divisor = best_divisor << 28;

    Delay (best_divisor);
*/
    LPC_GPIO4->DIR |= (1<<LED_PIN);
    LPC_GPIO4->CLR |= (1<<LED_PIN);

    unsigned char mode = 0;

    myinit_uart();

    while(1) {
	if (mode) {
	    LPC_GPIO4->SET |= (1<<LED_PIN);
	} else {
	    LPC_GPIO4->CLR |= (1<<LED_PIN);
	}

	sprintf ((char *)string, "Clock Speed: %d\n", 123);

	Delay (1000);
	UART_Send (LPC_UART0, string, strlen((char *)string), BLOCKING);

	mode ^=1;
    }
    return 0 ;
}
